% Der folgende Code testet zwei Orthogonalisierungsverfahren:
% Das Gram-Schmidt Verfahren und das QR-Verfahren
% Dies erfolgt mittels Anwedung auf die Matrix 
%       Z_ij = 1+ min(i,j) fuer 1 <= i, j <= 50.
% Wir betrachten auch ein modifiziertes Gram-Schmidt Verfahren
%
% Das resultierende Plot wird gespeichert als png-File. Siehe Ende.

% DIES IST EIN TEMPLATE. DIE STELLEN IN CAPS SOLLTEN DER AUFGABE
% ENTSPRECHEND GEAENDERT WERDEN.

%Matrix Definition
n = 50;
m = 50;
Z = zeros([m, n]);
for i = 1 : m
    for j = 1 : n
        % INITIALISIEREN SIE DIE Z MATRIX
    end
end

% Gram-Schmidt Verfahren

% INITIALISIEREN SIE DIE Q1 MATRIX MITTELS DER FUNKTION GR.
% DIE FUNCTION GR MUSS NICHT GEAENDERT WERDEN.


% Modifiziertes Gram-Schmidt Verfahren

% INITIALISIEREN SIE DIE Q2 MATRIX MITTELS DER FUNKTION GRmod.
% DIE FUNCTION GRmod MUSS NICHT GEAENDERT WERDEN.


% Matlab QR-implementation 

% INITIALISIEREN SIE DIE Q3 MATRIX MITTELS qr(...)


% Fehler Matrix
% SCHREIBEN SIE DEN FEHLER |Q^T * Q - I| FUER ALLE DREI METHODEN.
% Error1 = ... 
% Error2 = ...
% Error3 = ...

% --------------AB HIER GESCHIEHT ALLES AUTOMATISCH--------------

% Output: Maximaler Fehler
disp(['Gram-Schmidt liefert:      ' , num2str(max(max(Error1)))]);
disp(['Mod. Gram-Schmidt liefert: ' , num2str(max(max(Error2)))]);
disp(['Matlab-QR liefert:         ' , num2str(max(max(Error3)))]);

%Logarithmischer Fehler
logError1 = log(Error1+1e-16);
logError2 = log(Error2+1e-16);
logError3 = log(Error3+1e-16);

%% Plot
figure()

% 'surf' Achsen-Informationen
x = 1:m;
y = 1:n;

% 'colorbar' Informationen
bottom=mean(mean(logError3));
top=max(max(logError1));

% Plot: Gram-Schmidt Verfahren
subplot(2,2,1);
surf(x,y,logError1); 
view(2);
title({'Gram-Schmidt','log(|Q^{T} Q - I|)'})
axis tight 
axis equal
caxis manual
caxis([bottom top]);

% Plot: Modifiziertes Gram-Schmidt Verfahren
subplot(2,2,2);
surf(x,y,logError2); 
view(2);
title({' Mod. Gram-Schmidt','log(|Q^{T} Q - I|)'})
axis tight
axis equal
caxis manual
caxis([bottom top]);

% Plot: Matlab internes QR Verfahren
subplot(2,2,3);
surf(x,y,logError3); 
view(2);
title({' Matlab-QR','log(|Q^{T} Q - I|)'})
axis tight
axis equal
caxis manual
caxis([bottom top]);

colorbar

%Speichern des Plot
saveas(gcf, 'GramSchmidt-QR-Plot', 'png')